/*This function writes a div on the documents and then populates it
with the content it receives as argument. It is used for the JavaScript Callback method*/
var ERA_RC = window.ERA_RC||{};
ERA_RC.resource = function()
{
	var $={};
	return {
		init:function(elementID){
			document.write("<div class='eraLinksBlock' id='"+elementID+"'></div>");
			$.placeHolder=document.getElementById(elementID);
		},getContent:function(content){
		$.placeHolder.innerHTML=content.value;}
	};
}();
ERA_RC.era_el = "ERA_RC";
if (window.ERA_RC!='undefined' && window.ERA_RC['era_el']) ERA_RC.era_el=window.ERA_RC['era_el'];
ERA_RC.resource.init(ERA_RC.era_el);
(
function()
{
	// E|R|A related items interface link.
	var ERA_INTERFACE_LINK = '/ERALinks/Default.aspx';
	// Default E|R|A client domain.
	var DEFAULT_DOMAIN = 'sciencedirect.verticalsearchworks.com';
	// CSS link
	var DEFAULT_CSS_URL = 'CSS/altHtmlRelatedLinks.css';

	//This function writes the CSS link to the document. It is primarily used for related links JavaScript output.
	function WriteCSS(current_window, current_document)
	{
		if (DEFAULT_CSS_URL != "")
		{
			current_document.write("<link href='" + DEFAULT_CSS_URL + "' type='text/css' rel='stylesheet' />");
		}
	}

	//This function does the content ID retrieval.
	function GetCustomContentID()
	{
		var targetText = location.href;
return 'url:'+encodeURIComponent(targetText);		
	}

	//Gets UseIFrame status from ERA_RC
	function GetUseIFrame(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["UseIFrame"]  != null)
		{
			var val = current_window.era_rc1["UseIFrame"].toLowerCase();
			if (val == 'no' || val == 'false') return false;
		}
		
		//return true;
		return false;
	}

	//Gets url of the E|R|A related items interface.
	function GetEraDomain(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["ERADomain"] != null)
		{
			return "http://" + (current_window.era_rc1["ERADomain"]) + ERA_INTERFACE_LINK;
		}
		return "http://" + DEFAULT_DOMAIN + ERA_INTERFACE_LINK;
	}

	//Gets height from the ERA_RC array.
	function GetEraBlockHeight(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["Height"] != null)
		{
			return current_window.era_rc1["Height"];
		}
		return 400;
	}

	//Gets width from the ERA_RC array.
	function GetEraBlockWidth(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["Width"] != null)
		{
			return current_window.era_rc1["Width"];
		}
		return 330;
	}

	//Gets height from the ERA_RC array.
	function GetEraMaxItems(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["MaxRelatedItems"]  != null)
		{
			return current_window.era_rc1["MaxRelatedItems"];
		}
		return 4;
	}

	//Gets sort type from the ERA_RC array.
	function GetEraSortType(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["SortBy"] != null)
		{
			return current_window.era_rc1["SortBy"];
		}
		return 'Rank';
	}
	
	//Gets the PubID from the ERA_RC array.
	function GetPubID(current_window)
	{
	    if (current_window.era_rc1 != null && current_window.era_rc1["PubID"]  != null)
		{
			return current_window.era_rc1["PubID"];
		}
		return '';
	}

	//Gets content type from the ERA_RC array.
	function GetContentType(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["ContentType"] != null)
		{
			return current_window.era_rc1["ContentType"];
		}
		return 'SSMicrosites';
	}

	//Gets the content id from the ERA_RC array if supplied else calls the GetCustomContentID method to retrieve the content id from the URL.
	function GetContentId(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["ContentId"] != null)
		{
			return (current_window.era_rc1["ContentId"]);
		}
		else if (current_window.era_rc1 != null && current_window.era_rc1["CategoryIDs"] != null)
		{
			return '0&categoryids=' + current_window.era_rc1["CategoryIDs"];
		}
		else if (IsTestMode(current_window) && current_window.era_rc1["Test"] == 'true')
		{
			return '0';
		}
		else
		{
			return GetCustomContentID();
		}
	}

	//Gets the stylesheet to use
	function GetStylesheet(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["OverrideCss"] != null)
		{
			return (current_window.era_rc1["OverrideCss"]);
		}
		return '';
	}
	
	//Gets the style id to use
	function GetStyleId(current_window)
	{	
		if (current_window.era_rc1 != null && current_window.era_rc1["StyleId"] != null)
		{
			return (current_window.era_rc1["StyleId"]);
		}
		return '';
	}

	//Checks to see if the request is to be in test mode. (Randomly generated links)
	function IsTestMode(current_window)
	{
		if (current_window.era_rc1 != null && current_window.era_rc1["Test"] != null)
		{
			return current_window.era_rc1["Test"];
		}
		return false;
	}

	//Prints the related links IFrame to the document.
	function DisplayEraFrame(eraLink, current_document, current_window)
	{
		//current_document.write("<iframe name='era_relatedLinks' width='" + GetEraBlockWidth(current_window)+ "' height='" + GetEraBlockHeight(current_window) + "' frameborder='0' src='" + eraLink + "' marginwidth='0' marginheight='0' scrolling='no'>");
		current_document.write("</iframe>");
	}

	//Prints the related links JavaScript to the document.
	function DisplayEraJavaScript(eraLink, current_document, current_window)
	{
		current_document.write("<script type=\"text/javascript\" src=\"" + eraLink + "\"></script>");
	}

	//Adds double quotes to the provided string.
	function GetStringWithQuotes(checkString)
	{
		return checkString!=null ?'"'+ checkString + '"':'""'
	}
	
	function GetReferrer(current_window, current_document)
	{
        return current_document.referrer;			
	}
	
	function IsValidUrl(current_window, current_document)
	{
		return true
	}
	
	//Generates the related links request link using the link parameters.
	function CreateEraLink(current_window, current_document)
	{
		if (IsValidUrl(current_window, current_document))
		{
			var eraLink = GetEraDomain(current_window) + "?";
			
			eraLink += "ContentId=" + (GetContentId(current_window)) + "&numrequests=1&";
			eraLink += "req1=" + GetContentType(current_window) + "||";
			eraLink += GetEraMaxItems(current_window) + "|";
			eraLink += "SortBy:" + GetEraSortType(current_window);
			eraLink += "&Referrer=" + encodeURIComponent(GetReferrer(current_window, current_document));
			
			if (IsTestMode(current_window))
			{
				eraLink += "&Test=" + IsTestMode(current_window);
			}

			if (GetStyleId(current_window) != '')
			{
				eraLink += "&StyleId=" + GetStyleId(current_window);
			}

			if (GetStylesheet(current_window) != '')
			{
				eraLink += "&OverrideCss=" + GetStylesheet(current_window);
			}
			
			if (GetPubID(current_window) != '')
			{
			    eraLink += "&PubID=" + GetPubID(current_window);
			}

			// if UseIFrame property is set to no, write javascript, else use iframe
			if (GetUseIFrame(current_window))
			{
				eraLink += "&OutputType=html";
				DisplayEraFrame(eraLink, current_document, current_window);
			}
			else
			{
				eraLink += "&OutputType=javascript";
				DisplayEraJavaScript(eraLink, current_document, current_window);				
			}
		}
		current_window.era_rc1 = null;
	}

	//Calls functions to print the related links frame.
	function EraMain()
	{
		var current_window = window;
		var current_document = document;
		CreateEraLink(current_window, current_document);
	}
	EraMain();
})()
